// Globals.cpp

#include "stdafx.h"
#include "globals.h"

DWORD g_dwSVKModOrder[] =
{
    SVK_APPS,
    SVK_WIN,
    SVK_RWIN,
    SVK_CONTROL,
    SVK_RCONTROL,
    SVK_SHIFT,
    SVK_RSHIFT,
    SVK_MENU,
    SVK_RMENU,
    0
};

DWORD g_dwVKModOrder[] =
{
    VK_APPS,
    VK_LWIN,
    VK_RWIN,
    VK_CONTROL,
    VK_RCONTROL,
    VK_SHIFT,
    VK_RSHIFT,
    VK_MENU,
    VK_RMENU,
    0
};

// Global variables
BOOL g_bRegEx;
BOOL g_bWaitDate;
DATE g_dtWait;
BOOL g_bCaseSensitive;
TCHAR g_szEXEString[MAX_PATH];
BOOL g_bSent;
BOOL g_bListFailedWindows;
BOOL g_bWaitForSuccess;
BOOL g_bWaitForEnabled;
BOOL g_bRepeatForever;
BOOL g_bRestoreForeground;
BOOL g_bIncludeHidden;
BOOL g_bRenameWindow;
BOOL g_bMatchForegroundWindow;
BOOL g_bLeaveInBackground;
BOOL g_bFullHelp;
BOOL g_bQuiet;
BOOL g_bMatchClass;
BOOL g_bSendToEveryWindow;
BOOL g_bWaitForWindowNoExist;
BOOL g_bSendToParent;
BOOL g_bWaitForWindowDisabled;
int g_iDialogItemID[MAX_DIALOG_ID];
TCHAR g_szRename[256];
TCHAR g_szMatchClass[256];

DWORD StringToInteger(std::wstring str)
{
    TCHAR * szEnd;
    if (str.substr(0, 2).compare(_T("0x")) == 0)
    {
        return _tcstol(str.substr(2).c_str(), &szEnd, 16); 
    }
    return _tcstol(str.c_str(), &szEnd, 10);
}

DWORD ExpressionToInteger(std::wstring str, HWND hwnd)
{
    // This expression evaluator is only designed to understand
    // the expressions "w-number" and "h-number"

    TCHAR cToken = '\0';
    int iNum = 0;
    int iScreenMetric = 0;
    bool bSubtract = false;

    size_t i = 0;

    RECT rc, rcWindow;
    SystemParametersInfo(SPI_GETWORKAREA, 0, &rc, 0);
    GetWindowRect(hwnd, &rcWindow);

    while(i < str.length())
    {
        if (isdigit(str.at(i)))
        {
            std::wstring strNum = str.substr(i);
            iNum = StringToInteger(strNum);
            while (isdigit(str.at(i)))
            {
                i++;
                if (i >= str.length())
                    break;
            }

            continue;
        }

        switch(str.at(i))
        {
            case ' ':
            case '\t':
            case '\r':
            case '\n':
                break;

            case 'w':
                iScreenMetric = GetSystemMetrics(SM_CXSCREEN);
                if (str.length() > i+1)
                {
                    if (str.at(i+1) == 'w')
                    {
                        iScreenMetric = rcWindow.right - rcWindow.left;
                        i++;
                    }
                }
                break;
            case 'W':
                iScreenMetric = rc.right;
                break;

            case 'h':
                iScreenMetric = GetSystemMetrics(SM_CYSCREEN);
                if (str.length() > i+1)
                {
                    if (str.at(i+1) == 'h')
                    {
                        iScreenMetric = rcWindow.bottom - rcWindow.top;
                        i++;
                    }
                }
                break;
            case 'H':
                iScreenMetric = rc.bottom;
                break;

            case '-':
                bSubtract = true;
                break;

            case '+':
                bSubtract = false;
                break;
        }

        i++;
    }

    return bSubtract ? iScreenMetric - iNum : iScreenMetric + iNum;
}
